﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using DisqueRango;

namespace TrabLp
{
    class Atendimento
    {
        public DiskRango atendente(DiskRango diskrango)
        {
            string temp = "";
            string temp2 = "";
            string temp3 = "";
            Cliente cliente = new Cliente();
            ItemPedido itemPedido = new ItemPedido();
            bool existe = false;
            bool recadastro = false;
            bool flag = false;

            while (temp3.CompareTo("0") != 0)
            {
                existe = false;
                Pedido pedido = new Pedido();
                if (!recadastro)
                {
                    Console.WriteLine("Telefone(0 para sair):");
                    temp3 = Console.ReadLine();
                }
                if (temp3.CompareTo("0") == 0)
                {
                    //sai do programa...
                    Console.WriteLine("Programa encerrado");
                }
                else
                {
                    //varre o vetor de clientes para saber se já existe o cliente
                    for (int i = 0; i < diskrango.ListaClientes.Count; i++)
                    {
                        if (temp3.CompareTo(diskrango.ListaClientes[i].Telefone) == 0)
                        {
                            //se existe pega ele
                            existe = true;
                            cliente = diskrango.ListaClientes[i];
                            break;
                        }
                    }
                    //se não existir, cadastra
                    if (!existe)
                    {
                        cliente = new Cliente();
                        Console.WriteLine("Cliente não cadastrado. Novo cadastro:");
                        cliente.Telefone = temp3;
                        cadastro(cliente);
                        diskrango.ListaClientes.Add(cliente);
                    }
                        //comfirma o cadastro ou recadastra
                        Console.WriteLine("Cliente cadastrado:[C]onfirma ou [R]ecadastra?");
                        temp = Console.ReadLine();
                        //poderia ser usado o método toUpper ou toLower
                        if (temp.CompareTo("c") == 0 || temp.CompareTo("C") == 0)
                        {
                            recadastro = false;
                            pedido.Cliente = cliente;//add o cliente no pedido
                            while (temp.CompareTo("0") != 0)
                            {
                                Console.WriteLine("Adicionar item número(? para cardápio,0 para finalizar):");
                                temp = Console.ReadLine();
                                //switch irá adicionar os itens do cardapio no pedido
                                switch (temp)
                                {
                                    case "0":
                                        pedido.imprimirPedido();
                                        Console.WriteLine("Total: R$" + pedido.calculaTotal() + " - Confirma?");
                                        temp2 = Console.ReadLine();
                                        if (temp2.CompareTo("s") == 0 || temp2.CompareTo("S") == 0)
                                        {
                                            //processa o pedido e passa para o entregador
                                            for (int i = 0; i < diskrango.ListaEntregadores.Count; i++)
                                            {
                                                if (diskrango.ListaEntregadores[i].Presente)
                                                {
                                                    pedido.Entregador = diskrango.ListaEntregadores[i];
                                                    pedido.Entregador.Entregas++;
                                                    pedido.Entregador.Comissao += 0.05 * pedido.calculaTotal();
                                                    diskrango.ListaEntregadores[i].Presente = false;
                                                    diskrango.ListaEntregadores[(i + 1) % diskrango.ListaEntregadores.Count].Presente = true;
                                                    break;
                                                }
                                            }
                                            //Limpa o pedido.
                                            pedido.destroiPedido();
                                        }
                                        else
                                        {
                                            Console.WriteLine("Pedido Cancelado.");
                                            //Limpa o pedido.
                                            pedido.destroiPedido();
                                        }
                                        break;
                                    case "?":
                                        diskrango.imprimirRefeicao();
                                        break;
                                    //default insere o produto desejado
                                    default:
                                        existe = false;
                                        flag = false;
                                        //pecorre os itens de cardapio pra ver se existe o item
                                        for (int i = 0; i < diskrango.Cardapio.ItensCardapio.Count; i++)
                                        {
                                            if (temp.CompareTo(Convert.ToString(diskrango.Cardapio.ItensCardapio[i].Codigo)) == 0)
                                            {
                                                existe = true;
                                                itemPedido = new ItemPedido();
                                                itemPedido.ItemCardapio = diskrango.Cardapio.ItensCardapio[i];
                                                Console.WriteLine("\tAdicionando " + diskrango.Cardapio.ItensCardapio[i].Nome + " ao pedido. Quantidade:");
                                                temp2 = Console.ReadLine();
                                                //verifica se o item ja esta neste pedido
                                                for (int j = 0; j < pedido.ItensPedidos.Count; j++)
                                                {
                                                    if (temp.CompareTo(Convert.ToString(pedido.ItensPedidos[j].ItemCardapio.Codigo)) == 0)
                                                    {
                                                        flag = true;
                                                        pedido.ItensPedidos[j].Quantidade += Convert.ToInt32(temp2);
                                                    }
                                                }
                                                if (!flag)
                                                {
                                                    itemPedido.Quantidade = Convert.ToInt32(temp2);
                                                    pedido.ItensPedidos.Add(itemPedido);
                                                }
                                            }
                                        }
                                        if (!existe)
                                        {
                                            Console.WriteLine("\tNão há item com código " + temp + " no cardápio.");
                                        }
                                        break;
                                }
                            }
                        }
                        if (temp.CompareTo("r") == 0 || temp.CompareTo("R") == 0)
                        {
                            Console.WriteLine("Recadastrando cliente(telefone:" + cliente.Telefone + ")");
                            cadastro(cliente);
                            recadastro = true;
                        }
                }
            }
            return diskrango;
        }

        /// <summary>
        /// cadastra um novo cliente.
        /// </summary>
        /// <param name="cliente">cliente a ser cadastrado.</param>
        public void cadastro(Cliente cliente)
        {
            Console.WriteLine("Nome:");
            cliente.Nome = Console.ReadLine();
            Console.WriteLine("Endereço:");
            cliente.Endereco = Console.ReadLine();
            Console.WriteLine("Ponto de referência:");
            cliente.PontoReferencia = Console.ReadLine();
        }
    }
}
