﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DisqueRango
{
    class Entregador
    {
        private string nome;
        private bool presente;
        private string placa;
        private int entregas;
        private double comissao;
        private List<Pedido> listaPedidos;


        public Entregador(string nome,string placa)
        {
            this.nome = nome;
            this.placa = placa;
            this.Presente = false;
            listaPedidos = new List<Pedido>();
        }

        public string Nome
        {
            get { return nome; }
            set { nome = value; }
        }

        public string Placa
        {
            get { return placa; }
            set { placa = value; }
        }

        public bool Presente
        {
            get { return presente; }
            set { presente = value; }
        }

        public double Comissao
        {
            get { return comissao; }
            set { comissao = value; }
        }

        public int Entregas
        {
            get { return entregas; }
            set { entregas = value; }
        }

        internal List<Pedido> ListaPedidos
        {
            get { return listaPedidos; }
            set { listaPedidos = value; }
        }

    }
}
