﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DisqueRango
{
    class Pedido
    {
       private Cliente cliente;
       private List<ItemPedido> itensPedidos;
       private Entregador entregador;
       private DateTime data;
       private DateTime hora;

       public Pedido()
       {
           itensPedidos = new List<ItemPedido>();
       }
       internal Cliente Cliente
       {
           get { return cliente; }
           set { cliente = value; }
       }

       public DateTime Data
       {
           get { return data; }
           set { data = value; }
       }

       public DateTime Hora
       {
           get { return hora; }
           set { hora = value; }
       }

       internal List<ItemPedido> ItensPedidos
       {
           get { return itensPedidos; }
           set { itensPedidos = value; }
       }

       internal Entregador Entregador
       {
           get { return entregador; }
           set { entregador = value; }
       }

       public void imprimirPedido()
       {
           for (int i = 0; i < this.itensPedidos.Count; i++)
           {
               Console.Write(this.itensPedidos[i].ItemCardapio.Nome);
               Console.Write("--->");
               Console.WriteLine(this.itensPedidos[i].Quantidade);
           }
       }
       public void destroiPedido()
       {
           this.cliente = null;
           this.entregador = null;
           this.itensPedidos = null;
       }
       public double calculaTotal()
       {
           double total=0;
           for (int i = 0; i < itensPedidos.Count; i++)
           {
               total += itensPedidos[i].calculaPreço();
           }
           return total;
       }

       
    }
}
